=== ThirdParty/vtkm/vtkvtkm/vtk-m/vtkm/interop/anari/testing/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

vtkm_unit_tests(
SOURCES
  UnitTestANARIMapperGlyphs.cxx
  UnitTestANARIMapperPoints.cxx
  UnitTestANARIMapperTriangles.cxx
  UnitTestANARIMapperVolume.cxx
  UnitTestANARIScene.cxx
  )
